SOCKETPAIR(2) | System Calls Manual | SOCKETPAIR(2)

# NAME

`socketpair` —
create a pair of connected sockets

# LIBRARY

Standard C Library (libc, -lc)

# SYNOPSIS

`#include <sys/socket.h>`

int
`socketpair`(int d, int type, int protocol, int *sv);

# DESCRIPTION

The `socketpair`() call creates an unnamed pair of connected sockets in the specified domain d, of the specified type, and using the optionally specified protocol. The descriptors used in referencing the new sockets are returned in sv[0] and sv[1]. The two sockets are indistinguishable.

The type and protocol argument values are described in socket(2).

# RETURN VALUES

A 0 is returned if the call succeeds, -1 if it fails.

# ERRORS

The call succeeds unless:

[`EAFNOSUPPORT`]
  The specified address family is not supported on this machine.
[`EFAULT`]
  The address sv does not specify a valid part of the process address space.
[`EMFILE`]
  Too many descriptors are in use by this process.
[`ENFILE`]
  The system file table is full.
[`EOPNOTSUPP`]
  The specified protocol does not support creation of socket pairs.
[`EPROTONOSUPPORT`]
  The specified protocol is not supported on this machine.

# SEE ALSO

pipe(2), read(2), socket(2), write(2)

# HISTORY

The `socketpair`() function call appeared in 4.2BSD.

# BUGS

This call is currently implemented only for the `PF_LOCAL` domain.

June 24, 2011 | NetBSD 9.5